<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		galleries
 */

class Block_main_recent_galleries
{

	/**
	 * Standard modular info function.
	 *
	 * @return ?array	Map of module info (NULL: module is disabled).
	 */
	function info()
	{
		$info=array();
		$info['author']='Chris Graham';
		$info['organisation']='ocProducts';
		$info['hacked_by']=NULL;
		$info['hack_version']=NULL;
		$info['version']=2;
		$info['locked']=false;
		$info['parameters']=array('param','zone');
		return $info;
	}

	/**
	 * Standard modular cache function.
	 *
	 * @return ?array	Map of cache details (cache_on and ttl) (NULL: module is disabled).
	 */
	function cacheing_environment()
	{
		$info=array();
		$info['cache_on']='array(array_key_exists(\'zone\',$map)?$map[\'zone\']:get_module_zone(\'galleries\'),array_key_exists(\'param\',$map)?intval($map[\'param\']):10)';
		$info['ttl']=60;
		return $info;
	}

	/**
	 * Standard modular run function.
	 *
	 * @param  array		A map of parameters.
	 * @return tempcode	The result of execution.
	 */
	function run($map)
	{
		require_code('galleries');
		require_lang('galleries');

		$number=array_key_exists('param',$map)?intval($map['param']):10;
		$zone=array_key_exists('zone',$map)?$map['zone']:get_module_zone('galleries');

		$out=new ocp_tempcode();

		$rows1=$GLOBALS['SITE_DB']->query('SELECT DISTINCT g.name,g.add_date FROM '.$GLOBALS['SITE_DB']->get_table_prefix().'galleries g JOIN '.$GLOBALS['SITE_DB']->get_table_prefix().'images i ON g.name=i.cat WHERE i.add_date IS NOT NULL AND name NOT LIKE \''.db_encode_like('download\_%').'\' ORDER BY g.add_date DESC',$number);
		$rows2=$GLOBALS['SITE_DB']->query('SELECT DISTINCT g.name,g.add_date FROM '.$GLOBALS['SITE_DB']->get_table_prefix().'galleries g JOIN '.$GLOBALS['SITE_DB']->get_table_prefix().'videos i ON g.name=i.cat WHERE i.add_date IS NOT NULL AND name NOT LIKE \''.db_encode_like('download\_%').'\' ORDER BY g.add_date DESC',$number);
		$galleries=array_unique(collapse_2d_complexity('name','add_date',array_merge($rows1,$rows2)));
		arsort($galleries);

		if (count($galleries)==0)
		{
			return do_template('BLOCK_NO_ENTRIES',array('_GUID'=>'e6d16782037d35949646f95656382783','HIGH'=>false,'TITLE'=>do_lang_tempcode('RECENT',make_string_tempcode(integer_format($number)),do_lang_tempcode('GALLERIES')),'MESSAGE'=>do_lang_tempcode('NO_CATEGORIES'),'ADD_NAME'=>'','SUBMIT_URL'=>''));
		} else
		{
			foreach (array_keys($galleries) as $i=>$gallery)
			{
				if ($i==$number) break;

				$row=$GLOBALS['SITE_DB']->query_select('galleries',array('*'),array('name'=>$gallery),'',1);

				$out->attach(do_template('GALLERY_SUBGALLERY_WRAP',array('CONTENT'=>show_gallery_box($row[0],'root',true,$zone,false,true))));
			}
		}

		return do_template('BLOCK_MAIN_RECENT_GALLERIES',array('_GUID'=>'a7fca7d625a3d3af362735dad670f6eb','CONTENT'=>$out,'NUMBER'=>integer_format($number)));
	}

}


