<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		chat
 */

/**
 * Function to quickly (efficiently) check to see if there's been any chat activity.
 */
function chat_poller()
{
	$message_id=get_param_integer('message_id',-1);
	$event_id=get_param_integer('event_id',-1);
	if (
		((file_exists(get_custom_file_base().'/data_custom/modules/chat/chat_last_full_check.dat')) && (filemtime(get_custom_file_base().'/data_custom/modules/chat/chat_last_full_check.dat')>time()-3)) && // If we've done a check within the last 3 seconds don't try again (global flood control)
		(($message_id!=-1) && (file_exists(get_custom_file_base().'/data_custom/modules/chat/chat_last_msg.dat')) && (intval(file_get_contents(get_custom_file_base().'/data_custom/modules/chat/chat_last_msg.dat'))<=$message_id)) &&
		(($event_id!=-1) && (file_exists(get_custom_file_base().'/data_custom/modules/chat/chat_last_event.dat')) && (intval(file_get_contents(get_custom_file_base().'/data_custom/modules/chat/chat_last_event.dat'))<=$event_id))
	)
	{
		load_user_stuff();
		require_code('zones'); // Zone is needed because zones are where all ocPortal pages reside
		require_code('config'); // Config is needed for much active stuff
		require_code('users'); // Users are important due to permissions

		$room_id=get_param_integer('room_id',-1);
		require_code('chat');
		chat_room_prune($room_id);

		header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
		header("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); // Date in the past
		header('Content-Type: application/xml');

		$output='<?xml version="1.0" encoding="'.get_charset().'" ?'.'>
			<response>
				<result>
					<chat_null>'.strval($room_id).'</chat_null>
				</result>
			</response>';

		exit($output);
	}

	touch(get_custom_file_base().'/data_custom/modules/chat/chat_last_full_check.dat');
}
