<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		ocf_reported_posts
 */

class Hook_checklist_reported_posts
{

	/**
	 * Standard modular run function.
	 *
	 * @return array		An array of tuples: The task row to show, the number of seconds until it is due (or NULL if not on a timer), the number of things to sort out (or NULL if not on a queue), The name of the config option that controls the schedule (or NULL if no option).
	 */
	function run()
	{
		if (!addon_installed('ocf_forum')) return array();
		if (get_forum_type()!='ocf') return array();

		require_lang('ocf_config');

		$forum_id=$GLOBALS['FORUM_DRIVER']->forum_id_from_name(get_option('reported_posts_forum'));
		if (is_null($forum_id)) return array();
		$where='t_forum_id='.strval($forum_id);
		$query='SELECT COUNT(*) FROM '.$GLOBALS['FORUM_DB']->get_table_prefix().'f_topics ttop LEFT JOIN '.$GLOBALS['FORUM_DB']->get_table_prefix().'f_read_logs l ON (ttop.id=l.l_topic_id AND l.l_member_id='.strval((integer)get_member()).') LEFT JOIN '.$GLOBALS['FORUM_DB']->get_table_prefix().'translate t ON '.db_string_equal_to('language',user_lang()).' AND ttop.t_cache_first_post=t.id WHERE '.$where;
		$outstanding=$GLOBALS['FORUM_DB']->query_value_null_ok_full($query);

		if ($outstanding>0)
		{
			$status=do_template('BLOCK_MAIN_STAFF_CHECKLIST_ITEM_STATUS_0',array('_GUID'=>'e578142633c6f3d37776e82a869deb91'));
		} else
		{	
			$status=do_template('BLOCK_MAIN_STAFF_CHECKLIST_ITEM_STATUS_1',array('_GUID'=>'f578142633c6f3d37776e82a869deb91'));
		}

		$url=$GLOBALS['FORUM_DRIVER']->forum_url($forum_id,true);

		$tpl=do_template('BLOCK_MAIN_STAFF_CHECKLIST_ITEM',array('_GUID'=>'9ee69e250c997730a3670ed77d681e5f','URL'=>$url,'STATUS'=>$status,'TASK'=>do_lang_tempcode('REPORTED_POSTS_FORUM'),'INFO'=>do_lang_tempcode('NUM_QUEUE',escape_html(integer_format($outstanding)))));
		return array(array($tpl,NULL,$outstanding,NULL));
	}

}


