<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		ocf_forum
 */

class Hook_whats_news_ocf_forumview
{

	/**
	 * Standard modular run function for newsletter hooks.
	 *
	 * @return ?array				Tuple of result details: HTML list of all types that can be choosed, title for selection list (NULL: disabled)
	 */
	function choose_categories()
	{
		if (get_forum_type()!='ocf') return NULL;

		require_code('ocf_forums2');
		return array(ocf_get_forum_tree_secure(NULL,NULL,true),do_lang('SECTION_FORUMS'));
	}

	/**
	 * Standard modular run function for newsletter hooks.
	 *
	 * @param  TIME				The time that the entries found must be newer than
	 * @param  LANGUAGE_NAME	The language the entries found must be in
	 * @param  string				Category filter to apply
	 * @return array				Tuple of result details
	 */
	function run($cutoff_time,$lang,$filter)
	{
		$new=new ocp_tempcode();

		if (get_forum_type()!='ocf') return array();

		require_code('ocfiltering');
		$or_list=ocfilter_to_sqlfragment($filter,'t_forum_id');
		$rows=$GLOBALS['FORUM_DB']->query('SELECT * FROM '.$GLOBALS['FORUM_DB']->get_table_prefix().'f_topics WHERE t_cache_last_time>'.strval($cutoff_time).' AND t_validated=1 AND t_pt_to IS NULL AND t_pt_from IS NULL AND ('.$or_list.') ORDER BY t_cache_last_time DESC',300);
		if (count($rows)==300) return array();
		foreach ($rows as $row)
		{
			if (has_category_access($GLOBALS['FORUM_DRIVER']->get_guest_id(),'forums',strval($row['t_forum_id'])))
			{
				$_url=build_url(array('page'=>'topicview','type'=>'misc','id'=>$row['id']),get_module_zone('topicview'),NULL,false,false,true);
				$url=$_url->evaluate();
				$name=$row['t_cache_first_title'];
				$member_id=(is_guest($row['t_cache_first_member_id']))?NULL:strval($row['t_cache_first_member_id']);
				$new->attach(do_template('NEWSLETTER_NEW_RESOURCE_FCOMCODE',array('_GUID'=>'14a328f973ac44eb54aa9b31e5a4ae34','MEMBER_ID'=>$member_id,'URL'=>$url,'NAME'=>$name)));
			}
		}

		return array($new,do_lang('SECTION_FORUMS','','','',$lang));
	}

}


